<?php
namespace app\api\lists\property;

use app\api\lists\BaseApiDataLists;
use app\common\lists\ListsSearchInterface;
use app\common\model\property\PropertyCommission;
use app\common\model\property\PropertyHead;
use app\common\model\property\PropertyOrder;
use app\common\model\property\PropertySurplusLog;

/**
 * 订单列表
 */
class PropertyOrderLists extends BaseApiDataLists implements ListsSearchInterface
{

    public function setSearch(): array
    {
        return [
            '=' => ['id','order_status'],
        ];
    }
    public function queryWhere()
    {
        // 指定用户
        $propertyHeadId = PropertyHead::where('user_id',$this->userId)->value('id');
        $where[] = ['property_head_id', '=', $propertyHeadId];
        return $where;
    }
    public function lists(): array
    {
        $lists = PropertyOrder::with(['propertyHead','propertyUser','propertyWork'])->where($this->searchWhere)
            ->where($this->queryWhere())
            ->limit($this->limitOffset, $this->limitLength)
            ->field(['id','property_head_id','property_user_id','remark','order_status','work_id','create_time','update_time'])
            ->order('create_time desc')
            ->select()
            ->toArray();
        foreach ($lists as &$item){
            $item['householder_name'] = $item['propertyUser']?$item['propertyUser']['householder_name']:'';
            $item['householder_mobile'] = $item['propertyUser']?$item['propertyUser']['householder_name']:'';
            $item['work_address'] = $item['propertyWork']?$item['propertyWork']['address']:'';
            $item['work_create_time'] = $item['propertyWork']?$item['propertyWork']['create_time']:'';
        }
        return $lists;
    }

    /**
     * @notes  获取数量
     * @return int
     */
    public function count(): int
    {
        return PropertyOrder::where($this->searchWhere)->where($this->queryWhere())->count();
    }
}